/*
 * Copyright (C) 2006-2007 Andre Noll <maan@systemlinux.org>
 *
 * Licensed under the GPL v2. For licencing details see COPYING.
 */

/** \file dccp.c common functions of the dccp sender/receiver */

/*
 * based on common.c of dccp-cs-0.01.tar.bz2,
 * (C) 2005 Ian McDonald <imcdnzl@gmail.com>
 */

#include "para.h"
#include "error.h"
#include "dccp.h"
#include "fd.h"

/** \cond some magic dccp constants */
#define SOCK_DCCP 6
#define IPPROTO_DCCP 33
/** \endcond */

/**
 * obtain a dccp socket for sending/receiving
 *
 * \return the file descriptor of the new socket or \p -E_DCCP_SOCKET
 * on errors.
 */
int dccp_get_socket(void)
{
	int s = socket(AF_INET, SOCK_DCCP, IPPROTO_DCCP);

	if (s < 0)
		return -E_DCCP_SOCKET;
	return s;
}

/**
 * prepare a dccp socket
 *
 * \param fd the file descriptor of the socket
 *
 * \returns positive on success, negative on errors.
 */
int dccp_set_socket(__a_unused int fd)
{
	return 1;	/* nothing to do at the moment */
}
