/*
  File autogenerated by gengetopt version 2.21
  generated with the following command:
  gengetopt --no-handle-version --conf-parser --file-name=filter.cmdline --func-name filter_cmdline_parser --arg-struct-name=filter_args_info --set-package=para_filter --set-version=0.2.17 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "filter.cmdline.h"

const char *filter_args_info_purpose = "";

const char *filter_args_info_usage = "Usage: para_filter [OPTIONS]...";

const char *filter_args_info_description = "";

const char *filter_args_info_help[] = {
  "  -h, --help                Print help and exit",
  "  -V, --version             Print version and exit",
  "  -l, --loglevel=level      set loglevel (0-6)  (default=`4')",
  "  -f, --filter=filter_spec  Specify filter.\n\n                              May be given multiple times to 'pipe' the stream\n                              through arbitrary many filters in an efficient\n                              way.  The same filter may appear more than once,\n                              order matters.\n\n                              Filter options may be specified for each '-f'\n                              option separately. Note that you will have to\n                              quote these options like this:\n\n                              	-f 'compress --inertia 5 --damp 2'\n",
  "  -L, --list_filters        print list of available filters and exit  \n                              (default=off)",
    0
};

static
void clear_given (struct filter_args_info *args_info);
static
void clear_args (struct filter_args_info *args_info);

static int
filter_cmdline_parser_internal (int argc, char * const *argv, struct filter_args_info *args_info,
                        struct filter_cmdline_parser_params *params, const char *additional_error);

static int
filter_cmdline_parser_required2 (struct filter_args_info *args_info, const char *prog_name, const char *additional_error);
struct line_list
{
  char * string_arg;
  struct line_list * next;
};

static struct line_list *cmd_line_list = 0;
static struct line_list *cmd_line_list_tmp = 0;

static void
free_cmd_list(void)
{
  /* free the list of a previous call */
  if (cmd_line_list)
    {
      while (cmd_line_list) {
        cmd_line_list_tmp = cmd_line_list;
        cmd_line_list = cmd_line_list->next;
        free (cmd_line_list_tmp->string_arg);
        free (cmd_line_list_tmp);
      }
    }
}


struct string_list
{
  char * arg;
  char *orig;
  struct string_list * next;
};

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct filter_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->loglevel_given = 0 ;
  args_info->filter_given = 0 ;
  args_info->list_filters_given = 0 ;
}

static
void clear_args (struct filter_args_info *args_info)
{
  args_info->loglevel_arg = 4;
  args_info->loglevel_orig = NULL;
  args_info->filter_arg = NULL;
  args_info->filter_orig = NULL;
  args_info->list_filters_flag = 0;
  
}

static
void init_args_info(struct filter_args_info *args_info)
{
  args_info->help_help = filter_args_info_help[0] ;
  args_info->version_help = filter_args_info_help[1] ;
  args_info->loglevel_help = filter_args_info_help[2] ;
  args_info->filter_help = filter_args_info_help[3] ;
  args_info->filter_min = -1;
  args_info->filter_max = -1;
  args_info->list_filters_help = filter_args_info_help[4] ;
  
}

void
filter_cmdline_parser_print_version (void)
{
  printf ("%s %s\n", FILTER_CMDLINE_PARSER_PACKAGE, FILTER_CMDLINE_PARSER_VERSION);
}

void
filter_cmdline_parser_print_help (void)
{
  int i = 0;
  filter_cmdline_parser_print_version ();

  if (strlen(filter_args_info_purpose) > 0)
    printf("\n%s\n", filter_args_info_purpose);

  printf("\n%s\n\n", filter_args_info_usage);

  if (strlen(filter_args_info_description) > 0)
    printf("%s\n", filter_args_info_description);

  while (filter_args_info_help[i])
    printf("%s\n", filter_args_info_help[i++]);
}

void
filter_cmdline_parser_init (struct filter_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);
}

struct filter_cmdline_parser_params *
filter_cmdline_parser_params_init()
{
  struct filter_cmdline_parser_params *params = 
    (struct filter_cmdline_parser_params *)malloc(sizeof(struct filter_cmdline_parser_params));

  if (params)
    { 
      params->override = 0;
      params->initialize = 0;
      params->check_required = 0;
      params->check_ambiguity = 0;
    }
    
  return params;
}

static void
filter_cmdline_parser_release (struct filter_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->loglevel_orig)
    {
      free (args_info->loglevel_orig); /* free previous argument */
      args_info->loglevel_orig = 0;
    }
  if (args_info->filter_arg)
    {
      for (i = 0; i < args_info->filter_given; ++i)
        {
          if (args_info->filter_arg [i])
            {
              free (args_info->filter_arg [i]); /* free previous argument */
              args_info->filter_arg [i] = 0;
            }
          if (args_info->filter_orig [i])
            {
              free (args_info->filter_orig [i]); /* free previous argument */
              args_info->filter_orig [i] = 0;
            }
        }
      if (args_info->filter_arg [0])
        free (args_info->filter_arg [0]); /* free default string */
      free (args_info->filter_arg); /* free previous argument */
      args_info->filter_arg = 0;
      free (args_info->filter_orig); /* free previous argument */
      args_info->filter_orig = 0;
    }
  
  clear_given (args_info);
}

int
filter_cmdline_parser_file_save(const char *filename, struct filter_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", FILTER_CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->loglevel_given) {
    if (args_info->loglevel_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "loglevel", args_info->loglevel_orig);
    } else {
      fprintf(outfile, "%s\n", "loglevel");
    }
  }
  if (args_info->filter_orig)
    {
      for (i = 0; i < args_info->filter_given; ++i)
        {
          if (args_info->filter_orig [i])
            {
              fprintf(outfile, "%s=\"%s\"\n", "filter", args_info->filter_orig [i]);
            }
        }
    }
  if (args_info->list_filters_given) {
    fprintf(outfile, "%s\n", "list_filters");
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
filter_cmdline_parser_free (struct filter_args_info *args_info)
{
  filter_cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

static char *
get_multiple_arg_token(const char *arg)
{
  char *tok, *ret;
  size_t len, num_of_escape;
  int i, j;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');
  num_of_escape = 0;

  /* make sure it is not escaped */
  while (tok)
    {
      if (*(tok-1) == '\\')
        {
          /* find the next one */
          tok = strchr (tok+1, ',');
          ++num_of_escape;
        }
      else
        break;
    }

  if (tok)
    len = (size_t)(tok - arg + 1);
  else
    len = strlen (arg) + 1;

  len -= num_of_escape;

  ret = (char *) malloc (len);

  i = 0;
  j = 0;
  while (arg[i] && (j < len-1))
    {
      if (arg[i] == '\\' && 
	  arg[ i + 1 ] && 
	  arg[ i + 1 ] == ',')
        ++i;

      ret[j++] = arg[i++];
    }

  ret[len-1] = '\0';

  return ret;
}

static char *
get_multiple_arg_token_next(const char *arg)
{
  char *tok;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');

  /* make sure it is not escaped */
  while (tok)
    {
      if (*(tok-1) == '\\')
        {
          /* find the next one */
          tok = strchr (tok+1, ',');
        }
      else
        break;
    }

  if (! tok || strlen(tok) == 1)
    return 0;

  return tok+1;
}

static int
check_multiple_option_occurrences(const char *prog_name, unsigned int option_given, int min, int max, const char *option_desc);

int
check_multiple_option_occurrences(const char *prog_name, unsigned int option_given, int min, int max, const char *option_desc)
{
  int error = 0;

  if (option_given && ! (min < 0 && max < 0))
    {
      if (min >= 0 && max >= 0)
        {
          if (min == max)
            {
              /* specific occurrences */
              if (option_given != min)
                {
                  fprintf (stderr, "%s: %s option occurrences must be %d\n",
                    prog_name, option_desc, min);
                  error = 1;
                }
            }
          else if (option_given < min
              || option_given > max)
            {
              /* range occurrences */
              fprintf (stderr, "%s: %s option occurrences must be between %d and %d\n",
                prog_name, option_desc, min, max);
              error = 1;
            }
        }
      else if (min >= 0)
        {
          /* at least check */
          if (option_given < min)
            {
              fprintf (stderr, "%s: %s option occurrences must be at least %d\n",
                prog_name, option_desc, min);
              error = 1;
            }
        }
      else if (max >= 0)
        {
          /* at most check */
          if (option_given > max)
            {
              fprintf (stderr, "%s: %s option occurrences must be at most %d\n",
                prog_name, option_desc, max);
              error = 1;
            }
        }
    }
    
  return error;
}
int
filter_cmdline_parser (int argc, char * const *argv, struct filter_args_info *args_info)
{
  return filter_cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
filter_cmdline_parser_ext (int argc, char * const *argv, struct filter_args_info *args_info,
                   struct filter_cmdline_parser_params *params)
{
  int result;
  result = filter_cmdline_parser_internal (argc, argv, args_info, params, NULL);

  if (result == EXIT_FAILURE)
    {
      filter_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
filter_cmdline_parser2 (int argc, char * const *argv, struct filter_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  struct filter_cmdline_parser_params params;
  
  params.override = override;
  params.initialize = initialize;
  params.check_required = check_required;
  params.check_ambiguity = 0;

  result = filter_cmdline_parser_internal (argc, argv, args_info, &params, NULL);

  if (result == EXIT_FAILURE)
    {
      filter_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
filter_cmdline_parser_required (struct filter_args_info *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (filter_cmdline_parser_required2(args_info, prog_name, NULL) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      filter_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
filter_cmdline_parser_required2 (struct filter_args_info *args_info, const char *prog_name, const char *additional_error)
{
  int error = 0;

  /* checks for required options */
  if (check_multiple_option_occurrences(prog_name, args_info->filter_given, args_info->filter_min, args_info->filter_max, "'--filter' ('-f')"))
     error = 1;
  
  
  /* checks for dependences among options */

  return error;
}

int
filter_cmdline_parser_internal (int argc, char * const *argv, struct filter_args_info *args_info,
                        struct filter_cmdline_parser_params *params, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */
  char *multi_token, *multi_next; /* for multiple options */

  int i;        /* Counter */

  struct string_list * filter_list = NULL,* filter_new = NULL;
  int error = 0;
  struct filter_args_info local_args_info;
  
  int override;
  int initialize;
  int check_required;
  int check_ambiguity;
  
  override = params->override;
  initialize = params->initialize;
  check_required = params->check_required;
  check_ambiguity = params->check_ambiguity;

  if (initialize)
    filter_cmdline_parser_init (args_info);

  filter_cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "loglevel",	1, NULL, 'l' },
        { "filter",	1, NULL, 'f' },
        { "list_filters",	0, NULL, 'L' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVl:f:L", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          filter_cmdline_parser_print_help ();
          filter_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          if (local_args_info.version_given || (check_ambiguity && args_info->version_given))
            {
              fprintf (stderr, "%s: `--version' (`-V') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->version_given && ! override)
            continue;
          local_args_info.version_given = 1;
          args_info->version_given = 1;
          filter_cmdline_parser_free (&local_args_info);
          return 0;

        case 'l':	/* set loglevel (0-6).  */
          if (local_args_info.loglevel_given || (check_ambiguity && args_info->loglevel_given))
            {
              fprintf (stderr, "%s: `--loglevel' (`-l') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->loglevel_given && ! override)
            continue;
          local_args_info.loglevel_given = 1;
          args_info->loglevel_given = 1;
          args_info->loglevel_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->loglevel_orig)
            free (args_info->loglevel_orig); /* free previous string */
          args_info->loglevel_orig = gengetopt_strdup (optarg);
          break;

        case 'f':	/* Specify filter.
        
        May be given multiple times to 'pipe' the stream
        through arbitrary many filters in an efficient
        way.  The same filter may appear more than once,
        order matters.
        
        Filter options may be specified for each '-f'
        option separately. Note that you will have to
        quote these options like this:
        
        	-f 'compress --inertia 5 --damp 2'
.  */
          local_args_info.filter_given++;
        
          multi_token = get_multiple_arg_token(optarg);
          multi_next = get_multiple_arg_token_next (optarg);
        
          while (1)
            {
              filter_new = (struct string_list *) malloc (sizeof (struct string_list));
              filter_new->next = filter_list;
              filter_list = filter_new;
              filter_new->arg = gengetopt_strdup (multi_token);
              filter_new->orig = multi_token;
        
              if (multi_next)
                {
                  multi_token = get_multiple_arg_token(multi_next);
                  multi_next = get_multiple_arg_token_next (multi_next);
                  local_args_info.filter_given++;
                }
              else
                break;
            }
          break;

        case 'L':	/* print list of available filters and exit.  */
          if (local_args_info.list_filters_given || (check_ambiguity && args_info->list_filters_given))
            {
              fprintf (stderr, "%s: `--list_filters' (`-L') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->list_filters_given && ! override)
            continue;
          local_args_info.list_filters_given = 1;
          args_info->list_filters_given = 1;
          args_info->list_filters_flag = !(args_info->list_filters_flag);
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", FILTER_CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */


  if (local_args_info.filter_given && filter_list)
    {
      struct string_list *tmp;
      args_info->filter_arg = (char * *) realloc (args_info->filter_arg, (args_info->filter_given + local_args_info.filter_given) * sizeof (char *));
      args_info->filter_orig = (char **) realloc (args_info->filter_orig, (args_info->filter_given + local_args_info.filter_given) * sizeof (char *));
      for (i = (local_args_info.filter_given - 1); i >= 0; --i)
        {
          tmp = filter_list;
          args_info->filter_arg [i + args_info->filter_given] = filter_list->arg;
          args_info->filter_orig [i + args_info->filter_given] = filter_list->orig;
          filter_list = filter_list->next;
          free (tmp);
        }
    }
  

  args_info->filter_given += local_args_info.filter_given;
  local_args_info.filter_given = 0;
  
  if (check_required)
    {
      error += filter_cmdline_parser_required2 (args_info, argv[0], additional_error);
    }

  filter_cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  return 0;

failure:
  if (filter_list)
    {
      struct string_list *tmp;
      while (filter_list)
        {
          tmp = filter_list;
          free (filter_list->arg);
          free (filter_list->orig);
          filter_list = filter_list->next;
          free (tmp);
        }
    }
  
  filter_cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}

#ifndef CONFIG_FILE_LINE_SIZE
#define CONFIG_FILE_LINE_SIZE 2048
#endif
#define ADDITIONAL_ERROR " in configuration file "

#define CONFIG_FILE_LINE_BUFFER_SIZE (CONFIG_FILE_LINE_SIZE+3)
/* 3 is for "--" and "=" */

static int
_filter_cmdline_parser_configfile (char * const filename, int *my_argc)
{
  FILE* file;
  char my_argv[CONFIG_FILE_LINE_BUFFER_SIZE+1];
  char linebuf[CONFIG_FILE_LINE_SIZE];
  int line_num = 0;
  int result = 0, equal;
  char *fopt, *farg;
  char *str_index;
  size_t len, next_token;
  char delimiter;

  if ((file = fopen(filename, "r")) == NULL)
    {
      fprintf (stderr, "%s: Error opening configuration file '%s'\n",
               FILTER_CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  while ((fgets(linebuf, CONFIG_FILE_LINE_SIZE, file)) != NULL)
    {
      ++line_num;
      my_argv[0] = '\0';
      len = strlen(linebuf);
      if (len > (CONFIG_FILE_LINE_BUFFER_SIZE-1))
        {
          fprintf (stderr, "%s:%s:%d: Line too long in configuration file\n",
                   FILTER_CMDLINE_PARSER_PACKAGE, filename, line_num);
          result = EXIT_FAILURE;
          break;
        }

      /* find first non-whitespace character in the line */
      next_token = strspn (linebuf, " \t\r\n");
      str_index  = linebuf + next_token;

      if ( str_index[0] == '\0' || str_index[0] == '#')
        continue; /* empty line or comment line is skipped */

      fopt = str_index;

      /* truncate fopt at the end of the first non-valid character */
      next_token = strcspn (fopt, " \t\r\n=");

      if (fopt[next_token] == '\0') /* the line is over */
        {
          farg  = NULL;
          equal = 0;
          goto noarg;
        }

      /* remember if equal sign is present */
      equal = (fopt[next_token] == '=');
      fopt[next_token++] = '\0';

      /* advance pointers to the next token after the end of fopt */
      next_token += strspn (fopt + next_token, " \t\r\n");

      /* check for the presence of equal sign, and if so, skip it */
      if ( !equal )
        if ((equal = (fopt[next_token] == '=')))
          {
            next_token++;
            next_token += strspn (fopt + next_token, " \t\r\n");
          }
      str_index  += next_token;

      /* find argument */
      farg = str_index;
      if ( farg[0] == '\"' || farg[0] == '\'' )
        { /* quoted argument */
          str_index = strchr (++farg, str_index[0] ); /* skip opening quote */
          if (! str_index)
            {
              fprintf
                (stderr,
                 "%s:%s:%d: unterminated string in configuration file\n",
                 FILTER_CMDLINE_PARSER_PACKAGE, filename, line_num);
              result = EXIT_FAILURE;
              break;
            }
        }
      else
        { /* read up the remaining part up to a delimiter */
          next_token = strcspn (farg, " \t\r\n#\'\"");
          str_index += next_token;
        }

      /* truncate farg at the delimiter and store it for further check */
      delimiter = *str_index, *str_index++ = '\0';

      /* everything but comment is illegal at the end of line */
      if (delimiter != '\0' && delimiter != '#')
        {
          str_index += strspn(str_index, " \t\r\n");
          if (*str_index != '\0' && *str_index != '#')
            {
              fprintf
                (stderr,
                 "%s:%s:%d: malformed string in configuration file\n",
                 FILTER_CMDLINE_PARSER_PACKAGE, filename, line_num);
              result = EXIT_FAILURE;
              break;
            }
        }

    noarg:
      if (!strcmp(fopt,"include")) {
        if (farg && *farg) {
          result = _filter_cmdline_parser_configfile(farg, my_argc);
        } else {
          fprintf(stderr, "%s:%s:%d: include requires a filename argument.\n",
                  FILTER_CMDLINE_PARSER_PACKAGE, filename, line_num);
        }
        continue;
      }
      len = strlen(fopt);
      strcat (my_argv, len > 1 ? "--" : "-");
      strcat (my_argv, fopt);
      if (len > 1 && ((farg && *farg) || equal))
        strcat (my_argv, "=");
      if (farg && *farg)
        strcat (my_argv, farg);
      ++(*my_argc);

      cmd_line_list_tmp = (struct line_list *) malloc (sizeof (struct line_list));
      cmd_line_list_tmp->next = cmd_line_list;
      cmd_line_list = cmd_line_list_tmp;
      cmd_line_list->string_arg = gengetopt_strdup(my_argv);
    } /* while */

  if (file)
    fclose(file);
  return result;
}

int
filter_cmdline_parser_configfile (char * const filename,
                           struct filter_args_info *args_info,
                           int override, int initialize, int check_required)
{
  struct filter_cmdline_parser_params params;

  params.override = override;
  params.initialize = initialize;
  params.check_required = check_required;
  params.check_ambiguity = 0;
  
  return filter_cmdline_parser_config_file (filename, args_info, &params);
}

int
filter_cmdline_parser_config_file (char * const filename,
                           struct filter_args_info *args_info,
                           struct filter_cmdline_parser_params *params)
{
  int i, result;
  int my_argc = 1;
  char **my_argv_arg;
  char *additional_error;

  /* store the program name */
  cmd_line_list_tmp = (struct line_list *) malloc (sizeof (struct line_list));
  cmd_line_list_tmp->next = cmd_line_list;
  cmd_line_list = cmd_line_list_tmp;
  cmd_line_list->string_arg = gengetopt_strdup (FILTER_CMDLINE_PARSER_PACKAGE);

  result = _filter_cmdline_parser_configfile(filename, &my_argc);

  if (result != EXIT_FAILURE) {
    my_argv_arg = (char **) malloc((my_argc+1) * sizeof(char *));
    cmd_line_list_tmp = cmd_line_list;

    for (i = my_argc - 1; i >= 0; --i) {
      my_argv_arg[i] = cmd_line_list_tmp->string_arg;
      cmd_line_list_tmp = cmd_line_list_tmp->next;
    }

    my_argv_arg[my_argc] = 0;

    additional_error = (char *)malloc(strlen(filename) + strlen(ADDITIONAL_ERROR) + 1);
    strcpy (additional_error, ADDITIONAL_ERROR);
    strcat (additional_error, filename);
    result =
      filter_cmdline_parser_internal (my_argc, my_argv_arg, args_info,
                              params,
                              additional_error);

    free (additional_error);
    free (my_argv_arg);
  }

  free_cmd_list();
  if (result == EXIT_FAILURE)
    {
      filter_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}
